import type { App } from "./app.js";
import type { Collection } from "./collection_model.js";
import { type Field, type RecordLike, type SetterFinder, type SetterFunc, type RecordInterceptor } from "./field.js";
export declare const FieldTypeText = "text";
export declare const autogenerateModifier = ":autogenerate";
export declare const defaultLowercaseRecordIdPattern = "^[a-z0-9]+$";
export declare class TextField implements Field, SetterFinder, RecordInterceptor {
    #private;
    Name: string;
    Id: string;
    System: boolean;
    Hidden: boolean;
    Presentable: boolean;
    Help: string;
    Min: number;
    Max: number;
    Pattern: string;
    AutogeneratePattern: string;
    Required: boolean;
    PrimaryKey: boolean;
    Type(): string;
    GetId(): string;
    SetId(id: string): void;
    GetName(): string;
    SetName(name: string): void;
    GetSystem(): boolean;
    SetSystem(system: boolean): void;
    GetHidden(): boolean;
    SetHidden(hidden: boolean): void;
    ColumnType(_app: App): string;
    PrepareValue(_record: unknown, raw: unknown): string;
    ValidateValue(_ctx: unknown, app: App, record: RecordLike): Error | null;
    ValidatePlainValue(value: string): Error | null;
    private resolvePatternRegex;
    ValidateSettings(_ctx: unknown, _app: App, collection: Collection): Error | null;
    private checkOtherFieldsForPK;
    private checkAutogeneratePattern;
    CanInterceptAction(actionName: string): boolean;
    Intercept(_ctx: unknown, _app: App, record: RecordLike, actionName: string, actionFunc: () => Error | null | Promise<Error | null>): Error | null | Promise<Error | null>;
    private hasZeroValue;
    FindSetter(key: string): SetterFunc | null;
}
